| CMSIS-DSP Version 1.4.4 CMSIS DSP Software Library

- CMSIS
- CORE
- Driver
- DSP
- RTOS API
- Pack
- SVD

- Main Page
- Usage and Description
- Reference

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Functions
Sine
Fast Math Functions

## Functions

float32_t | arm_sin_f32 (float32_t x)
| Fast approximation to the trigonometric sine function for floating-point data.
q15_t | arm_sin_q15 (q15_t x)
| Fast approximation to the trigonometric sine function for Q15 data.
q31_t | arm_sin_q31 (q31_t x)
| Fast approximation to the trigonometric sine function for Q31 data.

## Description

Computes the trigonometric sine function using a combination of table lookup and cubic interpolation. There are separate functions for Q15, Q31, and floating-point data types. The input to the floating-point version is in radians while the fixed-point Q15 and Q31 have a scaled input with the range [0 +0.9999] mapping to [0 2*pi). The fixed-point range is chosen so that a value of 2*pi wraps around to 0.

The implementation is based on table lookup using 256 values together with cubic interpolation. The steps used are:

1. Calculation of the nearest integer table index
2. Fetch the four table values a, b, c, and d
3. Compute the fractional portion (fract) of the table index.
4. Calculation of wa, wb, wc, wd
5. The final result equals `a*wa + b*wb + c*wc + d*wd`

where

       a=Table[index-1];
       b=Table[index+0];
       c=Table[index+1];
       d=Table[index+2];

and

       wa=-(1/6)*fract.^3 + (1/2)*fract.^2 - (1/3)*fract;
       wb=(1/2)*fract.^3 - fract.^2 - (1/2)*fract + 1;
       wc=-(1/2)*fract.^3+(1/2)*fract.^2+fract;
       wd=(1/6)*fract.^3 - (1/6)*fract;

## Function Documentation

float32_t arm_sin_f32 | ( | float32_t | x | ) |

Parameters

  [in] | x | input value in radians.

Returns
  sin(x).

Examples:
  arm_linear_interp_example_f32.c, and arm_sin_cos_example_f32.c.

References FAST_MATH_TABLE_SIZE, and sinTable_f32.

Referenced by main().

q15_t arm_sin_q15 | ( | q15_t | x | ) |

Parameters

  [in] | x | Scaled input value in radians.

Returns
  sin(x).

The Q15 input value is in the range [0 +0.9999] and is mapped to a radian value in the range [0 2*pi).

References FAST_MATH_Q15_SHIFT, and sinTable_q15.

q31_t arm_sin_q31 | ( | q31_t | x | ) |

Parameters

  [in] | x | Scaled input value in radians.

Returns
  sin(x).

The Q31 input value is in the range [0 +0.9999] and is mapped to a radian value in the range [0 2*pi).

References FAST_MATH_Q31_SHIFT, and sinTable_q31.